const char glsl_rgb32_dir_bilinear_fsh_src[] =
"\n"
"#pragma optimize (on)\n"
"#pragma debug (off)\n"
"\n"
"uniform sampler2D     color_texture;\n"
"uniform vec2          color_texture_pow2_sz; // pow2 tex size\n"
"uniform vec4          vid_attributes;        // gamma, contrast, brightness\n"
"\n"
"// #define DO_GAMMA  1 // 'pow' is very slow on old hardware, i.e. pre R600 and 'slow' in general\n"
"\n"
"vec4 lutTex2D(in float x, in float y)\n"
"{\n"
"	return texture2D(color_texture, vec2(x, y));\n"
"}\n"
"\n"
"vec4 f_bilinear(in vec2 xy)\n"
"{\n"
"	// mix(x,y,a): x*(1-a) + y*a\n"
"	//\n"
"	// bilinear filtering includes 2 mix:\n"
"	//\n"
"	//   pix1 = tex[x0][y0] * ( 1 - u_ratio ) + tex[x1][y0] * u_ratio\n"
"	//   pix2 = tex[x0][y1] * ( 1 - u_ratio ) + tex[x1][y1] * u_ratio\n"
"	//   fin  =    pix1     * ( 1 - v_ratio ) +     pix2    * v_ratio\n"
"	//\n"
"	// so we can use the build in mix function for these 2 computations ;-)\n"
"	//\n"
"	vec2 uv_ratio     = fract(xy*color_texture_pow2_sz); // xy*color_texture_pow2_sz - floor(xy*color_texture_pow2_sz);\n"
"	vec2 one          = 1.0/color_texture_pow2_sz;\n"
"\n"
"	return mix ( mix( lutTex2D(xy.x, xy.y      ), lutTex2D(xy.x+one.x, xy.y      ), uv_ratio.x),\n"
"	             mix( lutTex2D(xy.x, xy.y+one.y), lutTex2D(xy.x+one.x, xy.y+one.y), uv_ratio.x), uv_ratio.y )\n"
"		;\n"
"}\n"
"\n"
"void main()\n"
"{\n"
"#ifdef DO_GAMMA\n"
"	vec4 gamma = vec4(1.0 / vid_attributes.r, 1.0 / vid_attributes.r, 1.0 / vid_attributes.r, 0.0);\n"
"\n"
"	// gamma, contrast, brightness equation from: rendutil.h / apply_brightness_contrast_gamma_fp\n"
"	vec4 color = pow( f_bilinear(gl_TexCoord[0].st) , gamma);\n"
"#else\n"
"	vec4 color = f_bilinear(gl_TexCoord[0].st);\n"
"#endif\n"
"\n"
"	// contrast/brightness\n"
"	gl_FragColor = (color * vid_attributes.g) + vid_attributes.b - 1.0;\n"
"}\n"
"\n"
;
